import java.util.Vector;
import java.io.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import RtCWPlayer;
import PlayerStats;
import java.util.*;

/**Die  Klasse <b>LogAnalyzer</b> ist ein logfile analyse programm fuer von
 * Return to Castle Wolfenstein erzeugte Logfiles.
 * <b>LogAnalyzer</b> ist von JFrame abgeleitet. Es wird das AWT Event Modell
 * benutzt.
 * @author wh|Abraxas
 * @version 2.0
 */
public class LogAnalyzer extends JFrame
{
	
	class LogDate  implements Serializable
    	{
		public void toStream(OutputStream fo) throws IOException
   		{
			ObjectOutputStream oo = new ObjectOutputStream(fo);
			oo.writeObject(this);
   		 }
        	/**Methode aus dem Interface Serializable
		 */
        	public  LogDate fromStream(InputStream fi)
		throws IOException,ClassNotFoundException
    		{
			ObjectInputStream oi = new ObjectInputStream(fi);
			LogDate list = (LogDate)oi.readObject();
			return list;
    		}
		//int day,year;
		String dayOfWeek,month,time,day,year;
	}
	LogDate date;
	playerList currPlayers;
	final String OUTDIR = "stats/";
	boolean readNames,add;
	JTextField tf_oEinheit; //Textfeld zur Eingabe des Namen fr die Obereinheit.
	JTextField tf_uEinheit; //Textfeld zur Eingabe des Namen fr die Untereinheit.
	JTextField tf_output; //Textfeld zur Ausgabe.
	JTextField tf_input; //Textfeld zur Eingabe des zu wechselnden Betrags.
	JTextField [] tf_value; //Textfelder zur Eingabe eigener Muenzsysteme
				//oder zur Ausgabe der Muenzwerte des
				//gewaehlten Standardsystems.
	JLabel l_oEinheit,l_uEinheit,l_values; //Beschriftungen fuer die
					       //Textfelder
	HTMLWriter writer;
	Vector playerNames;
	int killTotal=0,deathTotal=0,tkTotal = 0,playerTotal = 0,suicideTotal = 0;
	String server="No server info found";
	
	/**Der Konstruktor
	 * Hier wird das Fenster erzeugt, Variablen initialisiert und
	 * ActionListener erzeugt, um auf Eingaben reagieren zu koennen.
	 */
	public LogAnalyzer(boolean visible, String file)
	{
		writer = new HTMLWriter();
		date=new LogDate();
		String r;
		add=false;
		currPlayers = new playerList();
		/*try {
			history = currPlayers.loadList();
		} catch(Exception e) {
			System.out.println("\tfailed");
			System.out.println("Neue History anlegen....\tdone");
			history = new playerList();
		}*/
		setTitle("RtCW Logfile Analyzer");//Fensterueberschrift
		addWindowListener(new WindowAdapter() //WindowListener.
		//Notwendig, damit dass Fenster weiss, wie es auf Events wie z.B.
		// resize-Events oder close-Events zu reagieren hat.
		{
			//Fuer uns ist nur das schliessen des Fensters relevant,
			//weil dann auch das Programm beendet werden muss.
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);//Beende das Programm mit
					       //Fehlercode 0.
			}
		});
		//GridBagLayout fuer die graphische Oberflaeche. Die einzelnen
		//Widgets werden im Fenster in einem Raster angeordnet.
		getContentPane().setLayout(new GridBagLayout());
				
		//JPanel zur Anordnung der Buttons
		JPanel p2 = new JPanel();
		p2.setLayout( new GridLayout(1,0));//die Buttons sollen
		//nebeneinander liegen
		
		JButton b_close = new JButton("Beenden");//Button zum Beenden
		JRadioButton rb_mode;
		getContentPane().add(rb_mode = new JRadioButton("Aufaddieren?", false));
		
		//die Widgets werden ins RadioButton Panel eingefuegt.
		
		
		//die RadioButtons sollen noch etwas tun, wenn man sie anclickt,
		//deshalb benoetigen wir fuer sie ActionListener
		rb_mode.addActionListener(new ActionListener()
		{
			
			public void actionPerformed(ActionEvent e)
			{
				if (add) add=false;
				else add=true;
			}
		});
		
		JButton b_calcul = new JButton("Laden & Analysieren");//Button zum
					//Starten der Umrechnung
		//ActionListener fuer die Buttons
		b_close.addActionListener(new ActionListener()
		{
			//Wird dieser Button gedrueckt, soll das Programm beenden.
			public void actionPerformed(ActionEvent e)
			{
				//Programm beenden mit Fehlercode 0.
				System.exit(0);	
			}
		});
		b_calcul.addActionListener(new ActionListener()
		{
			//Nach Druecken dieses Buttons muss evtl. die neue
			// Waehrung instanziiert werden und dann die Berechnung
			// gestartet werden.
			public void actionPerformed(ActionEvent e)
			{
				if (!add)
				{
					currPlayers = new playerList();
					killTotal=0;deathTotal=0;tkTotal=0;playerTotal=0;
				}
				System.out.println(load());
				System.out.println("Insgesamt "+playerTotal+" Spieler geloggt"); 
				currPlayers.printList();
				System.out.println("Kills\t Deaths\t TKills\t");
				System.out.println(killTotal+"\t"+deathTotal+"\t"+tkTotal);
				writer.toHTML(currPlayers,null);
				//writer.toHTML(history,"history");
			//	history.saveList();
			
			}
		});
		//Die Buttons und den Abstandhalter zum Button Panel hinzufuegen
		p2.add(b_close);
		p2.add(rb_mode);
		p2.add(b_calcul);
	
		//Panel fuer die Textfelder zur Eingabe der Waehrungsnamen
		JPanel p3 = new JPanel();
		p3.setLayout( new GridLayout(1,0));//Widgets nebeneinander
						   //anordnen.
		l_oEinheit = new JLabel("Dateiname:");//Beschriftung
    		p3.add(l_oEinheit);//zum Panel hinzufuegen.
		tf_oEinheit = new JTextField(20);//Eingabefeld
		p3.add(tf_oEinheit);//zu Panel hinzufuegen.
		if (file != null) tf_oEinheit.setText(file);
		//Die 'Vorschriften' zur Platzierung der Widgets, die nun ins 
		//Fenster eingefuegt werden sollen.
		GridBagConstraints c = new GridBagConstraints();
		c.insets= new Insets(10,10,10,10);//Der Abstand zwischen
			//einzelnen Widgets untereinander und zum Rand
		c.fill = GridBagConstraints.HORIZONTAL;//die Widgets sollen in Ihrer 
					//Breite variabel dargestellt werden. 
		c.anchor = GridBagConstraints.CENTER;//Die Panels sollen mittig
						     //angeordnet werden
		c.gridheight = 1; c.gridwidth = GridBagConstraints.REMAINDER;
		
		getContentPane().add(p3,c);//Das Waehrungsnamen Panel
		
		c.insets= new Insets(20,20,20,20);//Die Buttons brauchen mehr Abstand
		getContentPane().add(p2,c);//Das Button Panel
		
		pack();
		setVisible(visible);//zeig Dich!
		if (!visible)
		{
			try{
			System.out.println(load(file));
			
			System.out.println("Kills\t Deaths\t TKills\t");
			System.out.println(killTotal+"\t"+deathTotal+"\t"+tkTotal);
			writer.toHTML(currPlayers,null);
			//writer.toHTML(history,"history");
			//history.saveList();
			}catch(Exception e){System.out.println(e);System.exit(1);} 
			System.exit(0);
		}
	}
	
	private boolean serverlocated=false;
	private boolean isIP(String isit)
	{
		char [] ip = isit.toCharArray();
		int dotcounter = 0;
		int portcounter = 0;
		for (int i=0;i<ip.length;i++)
		{
			if (ip[i] == '.') dotcounter++;
			if (ip[i] == ':') portcounter++;
		}
		if (dotcounter == 3 && portcounter == 1)
			return true;
		return false;
	}
	
	private int parseAndAnalyze(String zeile,int t)
	{
		StringTokenizer tokenizer = new
		StringTokenizer(zeile);
		int i=0,j=0,index=0,ttype;
		char c='1';
		String tb,ta,nam;
		String nom="";
		nam = tb = ta ="";
		//System.out.println("analyzing\t"+zeile);
		//char [] z = zeile.toCharArray();
		try {
			    if (tokenizer.hasMoreTokens())
			    {
			    	ta = tokenizer.nextToken();
			        if (ta==null) return 0;
				//System.out.println(ta);
				if (isIP(ta))
				{
				//	System.out.println("IP");
					if
					(tokenizer.nextToken().compareTo("resolved")==0
						&& tokenizer.nextToken().compareTo("to")==0
						&& isIP(tokenizer.nextToken()))
					{
						//System.out.println("IP: "+ta);
						server = ta;
						serverlocated = true;
					}
					return 0;
				}
				if (ta.compareTo("logfile") == 0)
				{
				
					
					ta = tokenizer.nextToken();
					if (ta==null) return 0;
					if (ta.compareTo("opened") == 0)
					{
						
						ta = tokenizer.nextToken();
			        		if (ta==null) return 0;
						if (ta.compareTo("on") == 0)
						{
							
							ta = tokenizer.nextToken();
							if (ta==null) return 0;
							date.dayOfWeek = ta;
							
							
							
							ta = tokenizer.nextToken();
			        			if (ta==null) return 0;
							date.month = ta;
							
							ta = tokenizer.nextToken();
							//ta = tokenizer.nval;
			        			//if (ta==null) return;
							//Double d = new
							//Double(tokenizer.nval);
							date.day = ta;
							
							//String dum = tokenizer.nextToken();
							//d = new Double(tokenizer.nval);
			        			//if (ta==null) return;
							
							
							
							ta = tokenizer.nextToken();
			        			date.time = ta;
							
							//if (ta==null) return;
							ta = tokenizer.nextToken();
							//d = new
							//Double(tokenizer.nval);
							date.year = ta;
							
							
							return 0;
						}
					}
							
				}
				
			    	if (ta.compareTo("LOADING...") == 0)
			    	{
					//System.out.print(ta+"\t");
			    		
				//if ((ttype = tokenizer.nextToken()) == StreamTokenizer.TT_WORD)
				//	ta = tokenizer.sval;
					//if((ttype=tokenizer.nextToken()) == StreamTokenizer.TT_WORD)
					//{
					//	ta = tokenizer.sval;
					//	//System.out.print(ta+"\t");
					//	if (readNames)
					//	{
							/*
							String ta2;
							tokenizer.nextToken();
							while ((ta2 = tokenizer.sval) != null)
							{
								ta += " "+ta2;
								tokenizer.nextToken();
							}
	//try{BufferedReader br=new BufferedReader(new InputStreamReader(System.in));br.readLine();}catch(Exception e){}
							System.out.println("addingPlayer \t"+ta);
							currPlayers.insertPlayer(new RtCWPlayer(ta));
							*/
					//	}
					//	if (ta.compareTo("clients") == 0)
			    		//	{
							//System.out.print(".");
					//		readNames = true;
					//	}
					//}
					//System.out.println(ttype);
					return 0;
			    } else {
				readNames = false;
				
				
			    	if (ta.startsWith("[skipnotify]"))
			    	{
				   	//System.out.println(ta);
				   	//try{BufferedReader br=new BufferedReader(new InputStreamReader(System.in));br.readLine();}catch(Exception e){}
				    	
				    	if (ta.endsWith(":")){
						//System.out.println("chat");
				    		return 0;
				    	}
			    	    	if (ta.endsWith("Server:"))
				    	{
						//System.out.println("Servermessage");
				    		return 0;
				    	}
					if (ta.endsWith("Invalid"))
				    	{
						//System.out.println("Servermessage");
				    		return 0;
				    	}
					if (ta.endsWith("Timelimit"))
				    	{
						//System.out.println("end of round");
				    		return 0;
				    	}
				    	nam = ta.substring(ta.indexOf(']',0)+1,ta.length()); //den Namen abtrennen
					if (nam.endsWith("^7)")||nam.endsWith("^7):")) return 0; //chat
					int k=0;
				    	while (!nam.endsWith("^7")) //die namen sind "^7 terminiert"
				    	{
						
						nam += " ";
						nam += tokenizer.nextToken();
						k++;
						if (k > 80||nam.endsWith("^7:")||nam.endsWith("^7)")) return 0;
						//chat
					}
					
					
					tb = tokenizer.nextToken();
					if (tb.endsWith("^7")){
						nam+=" "+tb;
						tb = tokenizer.nextToken();
					}
					//kill o..
					nam = nam.substring(0,nam.lastIndexOf('^')); //Name wird nicht ^7 terminiert abgespeichert
					//System.out.println("Killed:\t"+nam);
					
					
					RtCWPlayer p;
					
					if ((tb.compareTo("died") == 0)||(tb.compareTo("died.") == 0))
					{
						currPlayers.died(nam);
				//		history.died(nam);
						//System.out.print("died");
						return 0;
					}
					
					//System.out.println("...");
					if ((tb.compareTo("dove") == 0)||
						(tb.compareTo("killed") == 0)||
						(tb.compareTo("fell") == 0)||
						(tb.compareTo("obliterated") == 0))
					{
						if (tb.compareTo("obliterated") == 0)
						{
							currPlayers.suicide(nam,"support");
							//history.suicide(nam,"support");
							return 0;
						}
						if (tb.compareTo("fell") == 0)
						{
							currPlayers.suicide(nam,"fell");
							//history.suicide(nam,"support");
							return 0;
						}
						tb = tokenizer.nextToken();
						  
						//System.out.println(tb);
						while ((tb.compareTo("on") == 0)||
							(tb.compareTo("his") == 0)||
							(tb.compareTo("own") == 0))
						{
							tb = tokenizer.nextToken();
							//Grenade Diving
							//System.out.println(tb);
						}
						//System.out.println("oups");
						currPlayers.suicide(nam,tb);
				//		history.suicide(nam,tb);
						return 0;
					}
					
					if (tb.compareTo("was") == 0)
					{
						//System.out.print(tb+" ");
						tb = tokenizer.nextToken();
						//System.out.print(tb+" ");
						
						if ((tb.compareTo("killed.")== 0)||(tb.compareTo("crushed.") == 0))
						{
							currPlayers.died(nam);
				//			history.died(nam);
							//System.out.print(" by nobody");
							return 0;
						}
						boolean stabbed = false;
						while ((tb.compareTo("killed") == 0)||
							(tb.compareTo("by") == 0)||
							(tb.compareTo("blasted") == 0)||
							(tb.compareTo("perforated") == 0)||
							(tb.compareTo("exploded") == 0)||
							(tb.compareTo("cooked") == 0)||
							(tb.compareTo("ventilated") == 0)||
							(tb.compareTo("stabbed") == 0))
						{
							if
							(tb.compareTo("stabbed") == 0) stabbed = true;
							//System.out.print(tb+" ");
							if(tokenizer.hasMoreTokens())
							{
								tb = tokenizer.nextToken();
								//System.out.println(tb+" ");
							}
							else 
							{
								currPlayers.died(nam);
				//				history.died(nam);
								
							//*Player x was killed*
								return 0;
							}
							
						}
						
						//System.out.println();
						nom = tb;
						
						while (!nom.endsWith("^7\'s")&&!nom.endsWith("^7")&&!nom.endsWith("^7 \'s"))
						{
								
								nom += " ";
								nom += tokenizer.nextToken();
						}
						if (tokenizer.hasMoreTokens())
			    				tb = tokenizer.nextToken();
			    			else tb = "";
						while(tokenizer.hasMoreTokens())
						{
							tb += " "+tokenizer.nextToken();
							if (tb.endsWith("^7\'s")||tb.endsWith("^7 \'s")||tb.endsWith("^7"))
							{
								nom+= " "+tb;
								if (tokenizer.hasMoreTokens())
									tb = tokenizer.nextToken();
							}
						}
						nom = nom.substring(0,nom.lastIndexOf('^'));
						////System.out.println("Killer:\t"+nom);
						////System.out.println(nom);
						//System.out.println(tb);
						if (stabbed)
							currPlayers.kill(nam,nom,"knife");
						else currPlayers.kill(nam,nom,tb);
						//history.kill(nam,nom,tb);
						return 0;
					}
					else if (tb.compareTo("^1WAS") == 0)
					{
//try{BufferedReader br=new BufferedReader(new InputStreamReader(System.in));br.readLine();}catch(Exception e){}
						//System.out.println("TEAMKILL");
						if (tokenizer.hasMoreTokens())
							tb = tokenizer.nextToken();
						while ((tb.compareTo("KILLED") == 0)||
							(tb.compareTo("BY") == 0)||
							(tb.compareTo("TEAMMATE^7") == 0))
						{
							tb = tokenizer.nextToken();
						}
						
						nom = tb;
						
						while (!nom.endsWith("^7"))
						{
							
							nom += " ";
							nom += tokenizer.nextToken();
						}
						
						if (tokenizer.hasMoreTokens())
							tb = tokenizer.nextToken();
						else tb ="";
						if (tb.endsWith("^7")){
							nom+= " "+tb;
							
							tb = tokenizer.nextToken();
						}
						
						nom = nom.substring(0,nom.lastIndexOf('^'));
						
						currPlayers.teamKill(nam,nom);
				//		history.teamKill(nam,nom);
						return 0;
						
					}
					
					
				}
			    }
			    }
		}catch(Exception e){};
		return 0;
	}
	
	private int load()
	{
		
		String filename = "";
		try{
		    filename = tf_oEinheit.getText();
		}catch(Exception e){
		    tf_oEinheit.setText("Bitte geben Sie einen Dateinamen an.");
		    return -1;
		}
		return load(filename);
	}
	
	public int load(String filename)
	{
		readNames = false;
		int i=0;
		try{
		    
		    BufferedReader br=new BufferedReader(new FileReader(filename));
		    String zeile;
		    System.out.print("Einlesen und analysieren der Quelldatei.......");
		    while((zeile=br.readLine()) != null)
		    {
			if (parseAndAnalyze(zeile,0) == 1)
			{
				zeile=br.readLine();
				parseAndAnalyze(zeile,1);
			}
			i++;
		    }
	    	
		}catch(Exception e){
		    tf_oEinheit.setText("Die Datei konnte nicht gefunden werden.");
		     e.printStackTrace();
	    		System.out.println(e.getMessage());
		    return -1;
		}
		System.out.println("\t done.");
		System.out.println(""+i+" Zeilen gelesen");
		return 0;
    	}
	//Die main Methode bietet den Einstieg in das Programm. In Ihr wird nur
	// ein Objekt erzeugt, der Programmfluss wird dann vom
	// EventHandler uebernommen.
	public static void main(String [] args)
	{
	    	System.out.println("Starte Analyse...");
		try {
			new LogAnalyzer(false,args[0]);
	    	}catch(Exception e){new LogAnalyzer(true,null);}
	}

    private String plainTime()
    {
	    char [] t = date.time.toCharArray();
	    String neu = "";
	    char [] dummy = new char[1];
	    Character d,l;
	    for (int i=0;i<t.length;i++)
	    {
		    d = new Character(t[i]);
		    l = new Character(':');
		    if (d.compareTo(l)!=0)
		    {
			    dummy[0] = t[i];
			    neu += new String(dummy);
		    }
		    else neu += "$";
	    }
	    return neu;
    }
    
    public static String htmlColor(String s)
    {
	String m = "<font color=#ffffff>";
	int i=0;
	boolean first = true;
	char[] h = s.toCharArray();
        
	char[] d = new char[1];
        int l = h.length;
		while (i<h.length)
	    {
			while (i<l && (h[i] != '^' || (i< l-1 && h[i+1] == '^')))
		    	{
				d[0] = h[i];
				m += new String(d);
				i++;
		    	}
			
			if (!(i<h.length-1)) return m;
			if (first)
			{
			    switch(h[++i])
				{
					case '9':
					case 'q':
					case 'i':
					case 'y':
					case 'a':
					case '!':
					case '1': m += "<font color=#FF0000>";break;
					case 'r':
					case 'j':
					case 'z':
					case 'b':
					case '2': m += "<font color=#00FF00>";break;
					case 't':
					case 'k':
					case 's':
					case 'c':
				    	case '3': m += "<font color=#FFFF00>";break;
					case 'd':
					case 'l':
					case ',':
					case '$':
					case '4': m += "<font color=#0000FF>";break;
					case 'e':
					case 'u':
					case 'm':
					case '5': m += "<font color=#00FFFF>";break;
					case 'f':
					case 'v':
					case 'n':
					case '.':
					case '6': m += "<font color=#FF00FF>";break;
					case 'w':
					case 'o':
					case 'g':
                  			case '7': m += "<font color=#FFFFFF>";break;
					case '0':
					case 'p':
					case 'h':
					case 'x':
					case '8': m += "<font color=#000000>";break;
					default: d[0] = '^';
						 m+= new String(d);
						 d[0] = h[i];
						 m+= new String(d);
				}
			     
			    first = false;
			} else {
				switch(h[++i])
				{
					case '9':
					case 'q':
					case 'i':
					case 'y':
					case 'a':
					case '!':
					case '1': m += "<font color=#FF0000>";break;
					case 'r':
					case 'j':
					case 'z':
					case 'b':
					case '2': m += "<font color=#00FF00>";break;
					case 't':
					case 'k':
					case 's':
					case 'c':
				    	case '3': m += "<font color=#FFFF00>";break;
					case 'd':
					case 'l':
					case ',':
					case '$':
					case '4': m += "<font color=#0000FF>";break;
					case 'e':
					case 'u':
					case 'm':
					case '5': m += "<font color=#00FFFF>";break;
					case 'f':
					case 'v':
					case 'n':
					case '.':
					case '6': m += "<font color=#FF00FF>";break;
					case 'w':
					case 'o':
					case 'g':
                  			case '7': m += "<font color=#FFFFFF>";break;
					case '0':
					case 'p':
					case 'h':
					case 'x':
					case '8': m += "<font color=#000000>";break;
					default: d[0] = '^';
							 m+= new String(d);
							d[0] = h[i];
							m+= new String(d);
		    }
			   
		 }
			i++;	

				    
	    }
	    m += "</font>";
		return m;

    }

	
    public static String plainName(String s)
    {
	
	int i=0,j=0;
	
	char[] h = s.toCharArray();
        
		char[] d = new char[h.length];
        
		while (i<h.length)
	    {
			if ((h[i] > 0x0040 && h[i] < 0x005A)|| (h[i] > 0x0060 && h[i] <= 0x007A))
			{
				d[j] = h[i];
				j++;
			}
			i++;	
		}
				    
	    String k = new String(d);
		return k.trim();

    }
	
	public static void sort(PlayerStats a,int kill){

		switch (kill)
		{
			case RtCWPlayer.IKILLEDYOU: a.compareValue=a.kills;break;
			case RtCWPlayer.YOUKILLEDME: a.compareValue=a.deaths;break;
			case RtCWPlayer.ITKYOU: a.compareValue=a.tk;break;
			case RtCWPlayer.YOUTKME: a.compareValue=a.dtk;break;
		}
        for (int i=1;i<a.size;i++) {
            
            int x=a.compareValue[i];
			int k=a.kills[i];
			int d=a.deaths[i];
			int t=a.tk[i];
			String n=a.name[i];
			int td=a.dtk[i];
            int j=i;
            for (;(j>0) && (x>a.compareValue[j-1]);j--) //Arrayelemente verschieben bis x passt
			{
                a.compareValue[j]=a.compareValue[j-1];
				a.kills[j]=a.kills[j-1];
				a.deaths[j]=a.deaths[j-1];
				a.name[j]=a.name[j-1];
				a.tk[j]=a.tk[j-1];
				a.dtk[j]=a.dtk[j-1];
			}
            a.compareValue[j]=x; //x einfgen
			a.kills[j] = k;
			a.deaths[j] = d;
			a.tk[j] = t;
			a.dtk[j] = td;
			a.name[j] = n;
        }

    }
    
    
    		public static int numValue(String name)
		{
			if (name.compareTo("Jan")==0) return 1;
			if (name.compareTo("Feb")==0) return 2;
			if (name.compareTo("Mar")==0) return 3;
			if (name.compareTo("Apr")==0) return 4;
			if (name.compareTo("May")==0) return 5;
			if (name.compareTo("Jun")==0) return 6;
			if (name.compareTo("Jul")==0) return 7;
			if (name.compareTo("Aug")==0) return 8;
			if (name.compareTo("Sep")==0) return 9;
			if (name.compareTo("Oct")==0) return 10;
			if (name.compareTo("Nov")==0) return 11;
			if (name.compareTo("Dec")==0) return 12;
			return 0;
		}
		
		public static String stringValue(char num)
		{
			//System.out.println(num);
			switch (num)
			{
				case '1': return "Jan";
				case '2': return "Feb";
				case '3': return "Mar";
				case '4': return "Apr";
				case '5': return "May";
				case '6': return "Jun";
				case '7': return "Jul";
				case '8': return "Aug";
				case '9': return "Sep";
				default : return null;
			}
		}
    	
	
//==================================================================================//
//------------------------------------------------------------------------------//
//		        	CLASS PLAYERLIST
//------------------------------------------------------------------------------//
//=================================================================================//
		
	class playerList implements Serializable
	{
		private Player first;
	
    		/** Referenz auf das letzte Element der Liste (zum schnellen Anhaengen) */
    		private Player last;
		
    		/** Laenge der Liste */
    		public int length;
		ListSorter s;
		public long kills 	= 0;
		public long deaths 	= 0;
		public long tks 	= 0;
		public long suicides 	= 0;
	    //==========================================================================//
	    //-----------------------CLASS PLAYER---------------------------------------//
	    //==========================================================================//
    		/**
    		 * Die Klasse 'Player' representiert ein Element in der Liste.
    		 */
	   
    		private class Player implements Serializable
    		{
			RtCWPlayer	data;	/** das zu speichernde Datum */
			Player		next;	/** der Zeiger auf das naechste Element */
			public void toStream(OutputStream fo) throws IOException
   			{
				ObjectOutputStream oo = new ObjectOutputStream(fo);
				oo.writeObject(this);
   			 }
        		/**Methode aus dem Interface Serializable
			 */
        		public  Player fromStream(InputStream fi)
			throws IOException,ClassNotFoundException
    			{
				ObjectInputStream oi = new ObjectInputStream(fi);
				Player list = (Player)oi.readObject();
				return list;
    			}
	
    		}//End Class Player
	    //===========================================================================//
	    //===========================================================================//
    		/**
    		 * Konstruktor 
    		 */
    		public playerList()
    		{
			s = new ListSorter();
			first = last = null;
			length = 0;
    		}
	    //--------------------------------------------------------------------------//
		public void kill(String dead,String alive, String weapon)
		{
			RtCWPlayer d,a;
			d=insertPlayer(new RtCWPlayer(dead));
			a=insertPlayer(new RtCWPlayer(alive));
			a.killed(dead,weapon);
			d.gotKilled(alive,weapon);
			killTotal++;
			deathTotal++;
			kills++;
			deaths++;
		}
	    //-------------------------------------------------------------------------//
		public void teamKill(String dead,String alive)
		{
			RtCWPlayer d,a;
			d=insertPlayer(new RtCWPlayer(dead));
			a=insertPlayer(new RtCWPlayer(alive));
			a.teamKilled(dead);
			d.gotTeamKilled(alive);
			tkTotal++;
			deathTotal++;
			tks++;
			deaths++;
		}
	    //-----------------------------------------------------------------------//
		public void suicide(String dead,String weapon)
		{
			RtCWPlayer d = insertPlayer(new RtCWPlayer(dead));
			d.killedHimSelf(weapon);
			suicideTotal++;
			deathTotal++;
			suicides++;
		}
	    //-----------------------------------------------------------------------//
		public void died(String dead)
		{
			RtCWPlayer d = insertPlayer(new RtCWPlayer(dead));
			d.died();
			deathTotal++;
			deaths++;
		}
	    //----------------------------------------------------------------------//
    		public RtCWPlayer insertPlayer(RtCWPlayer p)
		{
			//System.out.println("Checking...");
			Player r;
			if ((r = contains(p.name))!=null) 
			{
				r.data.connect();
				return r.data;
			}
			append(p);
			playerTotal++;
			return p;
		}
	    //----------------------------------------------------------------------//
		/**
    		 * Die Methode 'prepend' fuegt ein Element am Anfang der Liste ein.
    		 * @param x das einzufuegende Element
    		 */
    		private void prepend( RtCWPlayer x )
    		{
    		    if( first == null ) {
    		        first = last = new Player();
    		        first.next = null;
    		        first.data = x;
    		    }
    		    else {
    		        Player temp = new Player();
    		        temp.data = x;
    		        temp.next = first;
    		        first = temp;
    		    }
    		    length++;
    		}
	    //----------------------------------------------------------------------//
    		/**	
    		 * Die Methode 'append' fuegt ein Element am Ende der Liste ein.
    		 * @param x das einzufuegende Element
    		 */
    		private void append( RtCWPlayer x )
    		{
		   //System.out.println("Appending...");
    		    if( first == null ) {
    		        first = last = new Player();
    		        first.next = null;
    		        first.data = x;
    		    }
    		    else {
    		        last.next = new Player();
    		        last = last.next;
    		        last.next = null;
    		        last.data = x;
    		    }
    		    length++;
    		}
	    //---------------------------------------------------------------------//
    		/**
    		 * Die Methode 'appendListFast' haengt die Liste 'tail an das Ende
    		 * der Liste, jedoch ohne die Elemente in 'tail' zu kopieren.
    		 * @param tail die anzuhaengende Liste
    		 */
    		public void appendListFast( playerList tail )
    		{
			if( first == null ) {
			    first = tail.first;
			    last = tail.last;
			    length = tail.length;
			}
			else {
			    last.next = tail.first;
			    last = tail.last;
			    length += tail.length;
			}
    		}
	    //--------------------------------------------------------------------//
    		/**
        	* Die Methode 'appendListSlow' haengt die Liste 'tail' an das Ende
    		 * der Liste. Dabei werden die Elemente von 'tail' kopiert.
    		 * @param tail die anzuhaengende Liste
     		*/
    		public void appendListSlow( playerList tail )
    		{
		Player temp = tail.first;
			
		while( !(temp == null) ) {
			    append(temp.data);
			    temp = temp.next;
			}
    		}
	    //-------------------------------------------------------------------//
    		/**
    		 * Die Methode 'isEmpty' ermittelt, ob die Liste leer ist.
    		 * @return true, wenn die List leer ist
    		 */
    		public boolean isEmpty()
    		{
			return first == null;
    		}
	    //------------------------------------------------------------------//
    		/**
    		 * Die Methode 'getFirst' gibt den Wert des ersten Elements zurueck.
    		 * @return der Wert des ersten Elements
    		 */
    		public RtCWPlayer getFirst()
    		{
			return first.data;
    		}
	    //-----------------------------------------------------------------//
    		/**
    		 * Die Methode 'removeFirst' entfernt das erste Element aus der
    		 * Liste und gibt es zurueck.
    		 * @return der Wert des ersten Elements
    		 */
    		public RtCWPlayer removeFirst()
    		{
			RtCWPlayer x = first.data;
			first = first.next;
			length--;
		
			return x;
    		}
	    //--------------------------------------------------------------//
    		/** Die Methode 'getLength' ermittelt die Laenge der Liste.
    		 * @return die Laenge der Liste
    		 */
    		public int getLength()
    		{
			return length;
    		}
		
	    //------------------------------------------------------------//
		
    		/**
    		 * Die Methode 'clone' erzeugt eine echte Kopie der Liste.
    		 * @return die Kopie der Liste
    		 */
    		public Object clone()
    		{
			playerList list = new playerList();
		
			for( Player temp = first; temp != null; temp = temp.next ) {
			    list.append(temp.data);
			}
			return list;
    		}
	    //--------------------------------------------------------------//
		public Player contains(String name)
		{
			if (isEmpty()) return null;
			int i = 0;
			Player p = first;
			while (i<length)
			{
				if (name.compareTo(p.data.getName()) == 0)
					return p;
			p = p.next;
				i++;
			}
			return null;
		}
	    //------------------------------------------------------------//
		public void printList()
		{
		        if (isEmpty()) return;
			Player p = s.Mergesort(first,RtCWPlayer.IKILLEDYOU);
			
			first = p;
			int i=0;
			System.out.println(playerTotal);
			System.out.println("Analyseergebnis:");
			while (p != null)
			{
			    PlayerStats stats = p.data.getStats();
			    stats = p.data.getStats();
			    //stats.print();
			    
			    p=p.next;
			}
		}
		 //------------------------------------------------------------//
		public PlayerStats[] getStats(int f)
		{
		        if (isEmpty()) return null;
			Player p = s.Mergesort(first,f);
			PlayerStats[] stats = new PlayerStats[length];
			first = p;
			int i=0;
			
			while (p != null)
			{
			    stats[i] = p.data.getStats();
			    i++;
			    p=p.next;
			}
			
			return stats;
		}
		/**Methode aus dem Interface Serializable
	 */
	public void toStream(OutputStream fo)
	throws IOException
   	{
		ObjectOutputStream oo = new ObjectOutputStream(fo);
		oo.writeObject(this);
   	 }
        /**Methode aus dem Interface Serializable
	 */
        public  playerList fromStream(InputStream fi)
	throws IOException,ClassNotFoundException
    	{
		ObjectInputStream oi = new ObjectInputStream(fi);
		playerList list = (playerList)oi.readObject();
		return list;
    	}
	/**Methode, um ein Addressbuch auf der Festplatte abzulegen
	 * Das Programm kann nur ein Addressbuch verwalten, dass in der Datei
	 * addresses.dat im Programmpfad gespeichert wird
	 */
	public void saveList()
	{
		System.out.print("Saving list...");
		try {
	    		this.toStream(new FileOutputStream("playerList.dat"));
		}
		catch (Exception e) {
	    		System.out.println(e);
	    		System.out.println("Fehler beim speichern.");
			return;
		}
		System.out.println("...done");
	}
	
	/**Methode um ein Addressbuch vonder Festplatte zu laden.
	 * Es muss eine Datei mit dem Namen addresses.dat vorhanden sein, in der
	 * zuvor ein Objekt der Klasse Addressbuch gespeichert wurde
	 */
	public playerList loadList() throws IOException,ClassNotFoundException
	{
		playerList addr=null;
		System.out.print("Loading playerlist....");
	    	addr = fromStream(new FileInputStream("playerList.dat"));
		System.out.println("..done");
		return addr;
	}
    //================================================================================================//
    //-------------------------------------CLASS LISTSORTER-------------------------------------------//
    //================================================================================================//
	class ListSorter implements Serializable
	{
		/**Methode aus dem Interface Serializable
	 */
	public void toStream(OutputStream fo)
	throws IOException
   	{
		ObjectOutputStream oo = new ObjectOutputStream(fo);
		oo.writeObject(this);
   	 }
        /**Methode aus dem Interface Serializable
	 */
        public  ListSorter fromStream(InputStream fi)
	throws IOException,ClassNotFoundException
    	{
		ObjectInputStream oi = new ObjectInputStream(fi);
		ListSorter sorter = (ListSorter)oi.readObject();
		return sorter;
    	}
	
	    /*---------------------------------------------------------------------------------------*/
	    //Mergesort
	    /*---------------------------------------------------------------------------------------*/
		private Player split(Player s)
		{
			Player newlist=s;
			Player dummy;
			if (s.next == null) return s;
			newlist = s.next;
			s.next=newlist.next;
			dummy = newlist;
			while (s.next != null)
			{
				s=s.next;
				dummy.next = s.next;
				dummy = dummy.next;
				if (dummy != null) s.next=dummy.next; else 
				s.next = null;
			}
			return newlist;
		}
	    /*-------------------------------------------------------------------------------------*/
		private Player merge(Player s,Player z,int f)
		{
			Player newlist;
			
			if (f!=RtCWPlayer.RATIO)
			{
				if (s.data.compare(f)>z.data.compare(f)) 
				{
					newlist =s;
					s=s.next;
				}
				else 
				{ 
					newlist=z;
					z=z.next;
				}
			} else {
				if (s.data.rateCompare()>z.data.rateCompare())
				{
					newlist =s;
					s=s.next;
				}
				else 
				{ 
					newlist=z;
					z=z.next;
				}
			}
			Player dummy=newlist;
			while ((s !=null) && (z !=null))
			{
				if (f!=RtCWPlayer.RATIO)
				{
					if (s.data.compare(f)>z.data.compare(f))
					{
						dummy.next=s;
						s=s.next;
					} else {
						dummy.next=z; 
						z=z.next;
					}
				} else {
					if (s.data.rateCompare()>z.data.rateCompare())
					{
						dummy.next=s;
						s=s.next;
					} else {
						dummy.next=z; 
						z=z.next;
					}
				}
				dummy = dummy.next;	
			}
			if (s==null) dummy.next = z; else dummy.next=s;
			return newlist;
		}
	    /*--------------------------------------------------------------------------------------------*/
		private Player ms(Player s,Player z,int f)
		{
			if (s.next == null) return s;
			z=split(s);
			s = ms(s,null,f);
			z = ms(z,null,f);
			return merge(s,z,f);
		}
	    /*------------------------------------------------------------------------------------------*/
		public Player Mergesort(Player s,int f)
		{
			return ms(s,null,f);
			//hierbei geht auf jeden Fall der last-Zeiger flten
		}
		
	    }//End Class Listsorter

        //==============================================================================================//
        //==============================================================================================//

	}//End Class playerList
	class indexWriter implements Serializable
    	{
		public void toStream(OutputStream fo) throws IOException
   		{
			ObjectOutputStream oo = new ObjectOutputStream(fo);
			oo.writeObject(this);
   		 }
        	/**Methode aus dem Interface Serializable
		 */
        	public  indexWriter fromStream(InputStream fi)
		throws IOException,ClassNotFoundException
    		{
			ObjectInputStream oi = new ObjectInputStream(fi);
			indexWriter list = (indexWriter)oi.readObject();
			return list;
    		}
    	
		
		private void sort(String a[])
		{
			
        		for (int i=1;i<a.length;i++) 
			{
          		    	String x=a[i];
				int j=i;
            			for (;(j>0) && (a[j-1].compareTo(x)<0);j--) //Arrayelemente verschieben bis x passt
				{
                			a[j]=a[j-1];
				}
            			a[j]=x; //x einfgen
        		}
			
    		}
		
		public indexWriter(String dir)
		{
	
			Date date = new Date();
			int statnum = 0;
			try{
			    
				File f = new File(dir);
				String [] Names = f.list();
				String [] fileNames = new String[Names.length];
				
				int p=0,i=0;
				if (Names!=null)
				{
					sort(Names);
					for (;p<Names.length;p++)
					{
						if (Names[p].indexOf('.')==-1 || Names[p].indexOf('-')==-1) continue;
						fileNames[i] = Names[p];
						i++;statnum++;
					}
					while(i<fileNames.length)
					{ 
						fileNames[i] =null;
						i++;
					}
		    		}
				else fileNames = null;
		    		BufferedWriter br=new BufferedWriter(new FileWriter("index.html"));
		    
		    		String zeile;
		    		zeile = "<html><html><head><title>Generated with Abraxas LogFileAnalyzer - http://www.wolfshorst.de/</title></head><body bgcolor=#808080 text=#FFFFFF>";
		    		br.write(zeile,0,zeile.length());
				br.newLine();
				//int mo = date.getMonth()+1;
				
				//zeile = "<small>"+date.getDay()+"."+mo+"."+(date.getYear()+1900)+" - "+date.getHours()+":"+date.getMinutes()+"</small><br>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<h1>Welcome to <font color=#0000FF>Ab</font><font color=#FF0000>r</font><font color=#0000FF>axas</font> RtCW Logfile Analyzer</h1><br>";
				zeile += "<h2>Index of "+statnum+" gamestat files</h2>";
				br.write(zeile,0,zeile.length());
				br.newLine();
			
			zeile = "<table width=100% border=0 cellspacing=0 cellpadding=5>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (fileNames != null)
			{
				/* Indexeintrag fr die History
					zeile = "<td bgcolor=#707070>";
					zeile += "<a href=\""+dir;
					zeile += "history.html";
					zeile += "\">Alle Spiele</a></td>";
					
					br.write(zeile,0,zeile.length());
					br.newLine();
				*/	
			for (i=0;i<fileNames.length && fileNames[i]!=null;i++)
			{
				br.write("<tr>",0,"<tr>".length());
				br.newLine();
				
				if ((i%2)==0)
				{
					zeile = "<td bgcolor=#909090>";
					zeile += "<a href=\""+dir;
					zeile += fileNames[i];
					zeile += "\">"+parseFilename(fileNames[i])+"</a></td>";
					
					br.write(zeile,0,zeile.length());
					br.newLine();
					

				} else {
					zeile = "<td bgcolor=#707070>";
					zeile += "<a href=\""+dir;
					zeile += fileNames[i];
					zeile += "\">"+parseFilename(fileNames[i])+"</a></td>";
					
					br.write(zeile,0,zeile.length());
					br.newLine();
					
				}
				
				br.write("</tr>",0,"</tr>".length());
					br.newLine();
			}
			}
			br.write("</table>",0,"</table>".length());
					br.newLine();
		  
			zeile = "<br><hr>HTML Page generated with Abraxas java Analyzer - <a href='http://www.wolfshorst.de'>http://www.wolfshorst.de</a></body></html>";
			br.write(zeile,0,zeile.length());
			br.newLine();
	
		  br.close();

		}catch(Exception e){
		    tf_oEinheit.setText("Die Datei konnte nicht erstellt werden.");
		     e.printStackTrace();
	    	System.out.println(e.getMessage());
		    return;
		}
    
		}
		private String parseFilename(String fn)
		{
			String date="";
			
			char[] f = fn.toCharArray();
			if (f[4] == '0')
				date += f[6]+""+f[7]+". "+LogAnalyzer.stringValue(f[5])+" "+f[0]+f[1]+f[2]+f[3];
			else {
				if (f[5] == '0')
					date += f[6]+""+f[7]+". Oct "+f[0]+f[1]+f[2]+f[3];
				else if (f[5] == '1')
					date += f[6]+""+f[7]+". Nov "+f[0]+f[1]+f[2]+f[3];
				else 
					date += f[6]+""+f[7]+". Dec "+f[0]+f[1]+f[2]+f[3];
			}
			int i;
			date += "<br>";
			if (f[10]=='$'){ date += "0"+f[9];i=11;}
			else{ date += ""+f[9]+f[10];i=12;}
			
			date += ":"+f[i]; i++;
			date += f[i]; i += 2;
			date += ":"+f[i]; i++;
			date += f[i]; 
			
			
			return date;
		}
		
	}
	class HTMLWriter implements Serializable
    	{
		public void toStream(OutputStream fo) throws IOException
   		{
			ObjectOutputStream oo = new ObjectOutputStream(fo);
			oo.writeObject(this);
   		 }
        	/**Methode aus dem Interface Serializable
		 */
        	public  HTMLWriter fromStream(InputStream fi)
		throws IOException,ClassNotFoundException
    		{
			ObjectInputStream oi = new ObjectInputStream(fi);
			HTMLWriter list = (HTMLWriter)oi.readObject();
			return list;
    		}
		
	//---------------------------------------------------------------------
	//--- PERSONALHTML-----------------------------------------------------
	//---------------------------------------------------------------------
	private void personalHTML(PlayerStats stats,String link)
	{
		if (stats == null) return;
	try{
		BufferedWriter br=new BufferedWriter(new FileWriter(OUTDIR+link+"/"+plainName(stats.player)+".html"));
		String zeile;
		zeile = "<html><html><head><title>Generated with Abraxas LogFileAnalyzer - http://www.wolfshorst.de/</title></head><body bgcolor=#808080 text=#FFFFFF link=#0000ff alink=#ffffff vlink=#0000ff>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<div align=center><h1>Player Details for "+htmlColor(stats.player)+"</h1><br><br></div>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<small><font color=#0000FF>Match Date "+date.dayOfWeek+" "+date.day+" "+date.month+" "+date.year+" "+date.time+"</small><br>on Server:</font><font color=#FF0000> "+server+"</font><br>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<a href=\"../"+link+".html\">match overview</a><br><div align=center><br>";
		
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<table width=100% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center><font color=#FFFFFF><br><b><big>Player total</big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kills</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Killed</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kill / Killed ratio</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Deaths total</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamkills</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamkilled</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Longest killingspree</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Suicides</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		br.write("<tr>",0,"<tr>".length());
		br.newLine();
			
		zeile = "<td bgcolor=#909090>";
		zeile += stats.ktotal;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.gotKilled;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.ratio;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.dtotal;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.tktotal;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.tkdtotal;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.longestSpree;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<td bgcolor=#909090>";
		zeile += stats.suicides;
		zeile += "</td>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		
		br.write("</table>",0,"</table>".length());
		br.newLine();
		
		
		
		zeile = "<table width=100% border=0 cellspacing=0 cellpadding=0><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<table width=25% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center>";
		zeile += "<font color=#FFFFFF><br><b><big>KilledPlayers ";
		zeile += "<font color=#00FF00>"+stats.ktotal+"</font></big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kills</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>more info</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		int j=0;
		sort(stats,RtCWPlayer.IKILLEDYOU);
		for (int i=0;i<stats.size;i++)
		{
			if (stats.kills[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.kills[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			} else {
				
				zeile = "<td bgcolor=#707070>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.kills[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
				br.newLine();
		}
		br.write("</table></th>",0,"</table></th>".length());
		br.newLine();
		zeile = "<th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<table width=25% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center>";
		zeile += "<font color=#FFFFFF><br><b><big>Killed by Players <font color=#FF0000>"+stats.gotKilled+"</font></big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Deaths</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>more info</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		j=0;
		sort(stats,RtCWPlayer.YOUKILLEDME);
		for (int i=0;i<stats.size;i++)
		{
			if (stats.deaths[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.deaths[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			} else {
				
				zeile = "<td bgcolor=#707070>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.deaths[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
				br.newLine();
		}
		br.write("</table>",0,"</table>".length());
				br.newLine();
		zeile = "</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		  zeile = "<table width=25% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();

		zeile = "<th align=left text=#FFFFFF><div align=center><font color=#FFFFFF><br><b><big>Teamkills <font color=#FF0000>"+stats.tktotal+"</font></big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamkills</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>more info</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		j=0;
		sort(stats,RtCWPlayer.ITKYOU);
		for (int i=0;i<stats.size;i++)
		{
			if (stats.tk[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.tk[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			} else {
					
				zeile = "<td bgcolor=#707070>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.tk[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
				br.newLine();
		}
		br.write("</table>",0,"</table>".length());
		br.newLine();
		zeile = "</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<table width=25% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center><font color=#FFFFFF><br><b><big>Teamkilled by player <font color=#FF0000>"+stats.tkdtotal+"</font></big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamdeaths</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>more info</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		j=0;
		sort(stats,RtCWPlayer.YOUTKME);
		for (int i=0;i<stats.size;i++)
		{
			if (stats.dtk[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.dtk[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
			} else {
				
				zeile = "<td bgcolor=#707070>";
				zeile += htmlColor(stats.name[i]);
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.dtk[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += "<a href=\"";
				zeile += plainName(stats.name[i]);
				zeile += ".html\">info</a></td>";
				
				br.write(zeile,0,zeile.length());
				br.newLine();
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
				br.newLine();
		}
		br.write("</table>",0,"</table>".length());
		br.newLine();
		zeile = "</th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<table width=50% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center><font color=#FFFFFF><br><b><big>Kill Weapons</big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Weapon name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kills</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		j=0;
		
		for (int i=0;i<15;i++)
		{
			if (stats.kWeapons[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += RtCWPlayer.WEAPONNAME[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.kWeapons[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			} else {
				zeile = "<td bgcolor=#707070>";
				zeile += RtCWPlayer.WEAPONNAME[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.kWeapons[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
				br.newLine();
		}
		br.write("</table>",0,"</table>".length());
		br.newLine();
		zeile = "</th><th align=top>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<table width=50% border=0 cellspacing=0 cellpadding=5><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left text=#FFFFFF><div align=center><font color=#FFFFFF><br><b><big>Death Weapons</big></b><br></font></div></th></tr><tr>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Weapon name</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Deaths</th>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		br.write("</tr>",0,"</tr>".length());
		br.newLine();
		j=0;
		
		for (int i=0;i<15;i++)
		{
			if (stats.dWeapons[i] == 0) continue;
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			if ((j%2)==0)
			{
				
				zeile = "<td bgcolor=#909090>";
				zeile += RtCWPlayer.WEAPONNAME[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#909090>";
				zeile += stats.dWeapons[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			} else {
				zeile = "<td bgcolor=#707070>";
				zeile += RtCWPlayer.WEAPONNAME[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				zeile = "<td bgcolor=#707070>";
				zeile += stats.dWeapons[i];
				zeile += "</td>";
				br.write(zeile,0,zeile.length());
				br.newLine();
				
			}
			j++;
			br.write("</tr>",0,"</tr>".length());
			br.newLine();
		}
		br.write("</table>",0,"</table>".length());
		br.newLine();
		zeile = "</th></table>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		
		


		zeile = "<a href=\"../"+link+".html\">match overview</a>";
		br.write(zeile,0,zeile.length());
		br.newLine();
		zeile = "<br><hr>HTML Page generated with Abraxas java Analyzer - <a href='http://www.wolfshorst.de'>http://www.wolfshorst.de</a></div></body></html>";
		br.write(zeile,0,zeile.length());
		br.newLine();
			
		 br.close();

		}catch(Exception e){
		    tf_oEinheit.setText("Die Datei konnte nicht erstellt werden.");
		     e.printStackTrace();
	    	System.out.println(e.getMessage());
		    return;
		}

	}
	public void toHTML(playerList rawStats, String file)
    {
	PlayerStats[] stats = rawStats.getStats(RtCWPlayer.IKILLEDYOU);
	
	String filename,filename2;
	if (file==null)
	{
		if (numValue(date.month) < 10)
		{
			filename  = ""+(date.year)+"0"+numValue(date.month);
			filename2 = "_"+(date.year)+"0"+numValue(date.month);
		} else {
			filename  = ""+(date.year)+numValue(date.month);
			filename2 = "_"+(date.year)+numValue(date.month);
		}
		
		filename  += date.day+"-";
		filename2 += date.day;
		
		filename  += plainTime();
		filename2 += plainTime();

	}else{
		filename  = file;
		filename2 = "_"+file;
	}
	
	try{
		    
			File f = new File(OUTDIR+filename);
			f.mkdir();
			
			f = new File(OUTDIR+".path");
			
			File j = new File(f.getAbsolutePath().substring(0,f.getAbsolutePath().indexOf('.')));
			
			File g = new File(j.getAbsolutePath());
			String [] dirNames = g.list();
			String lastGame;
			
			int p=0;
			if (dirNames!=null)
			{
			while (p<dirNames.length && dirNames[p].indexOf('.')!=-1) p++;//erstes Verzeichnis suchen
			if (p<dirNames.length) lastGame = dirNames[p];
			else lastGame="";
			for (;p<dirNames.length;p++)
			{
				if (dirNames[p].indexOf('.')!=-1) continue;
				if (lastGame.compareTo(dirNames[p])<0) 
				{
					if (dirNames[p].compareTo(filename)==0) continue;
					lastGame = dirNames[p];
				}
			}
		    	}
			else lastGame="";
		    BufferedWriter br=new BufferedWriter(new FileWriter(OUTDIR+filename+".html"));
		    if (file ==null) System.out.println("Schreibe aktuelles Spiel\t");
		    else System.out.println("Schreibe History\t");
		    int h=0;
		    while (h<7)
		    {
			    
			System.out.print(".index"+h+".");
		    	String zeile;
		    	zeile = "<html><html><head><title>Generated with wh|Abraxas LogFileAnalyzer - http://www.wolfshorst.de/</title></head><body bgcolor=#808080 text=#FFFFFF link=#0000ff alink=#ffffff vlink=#0000ff>";
		    	br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<div align=\"Center\"><h1>Match Overview</h1><br><h2>Server: <font color=#FF0000>"+server+"</font></h2></div><br>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = ""+date.day+"."+date.month+"."+date.year+" - "+date.time+"<br>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<td bgcolor=#707070>";
			zeile += "<a href=\"..\\index.html\">Overview</a></td>";	
			br.write(zeile,0,zeile.length());
			br.newLine();
			System.out.print("..");		
			zeile = "<table width=100% border=0 cellspacing=0 cellpadding=5><tr>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player name</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kills</th>";
			else if (h>0)
					zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\"../"+filename+".html\">Kills</a></th>";
				else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+".html\">Kills</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==6)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Killed</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"6.html\">Killed</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"6.html\">Killed</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==2)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kill / Death ratio</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"2.html\">Kill / Death ratio</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"2.html\">Kill / Death ratio</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==1)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Deaths total</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"1.html\">Deaths total</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"1.html\">Deaths total</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==3)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamkills</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"3.html\">Teamkills</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"3.html\">Teamkills</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==4)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Teamkilled</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"4.html\">Teamkilled</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"4.html\">Teamkilled</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			if (h==5)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Suicides</th>";
			else if (h>0)
				zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename2+"5.html\">Suicides</a></th>";
			else zeile = "<th align=left bgcolor=#000000 text=#FFFFFF><a href=\""+filename+"/"+filename2+"5.html\">Suicides</a></th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>more info</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			
			br.write("</tr>",0,"</tr>".length());
			br.newLine();
			int i;
			for (i=0;i<stats.length;i++)
			{
				br.write("<tr>",0,"<tr>".length());
				br.newLine();
				System.out.print(".");
				if (h == 0) personalHTML(stats[i],filename);
				if (stats[i] == null) continue;
				if ((i%2)==0)
				{
					zeile = "<td bgcolor=#909090>";
					zeile += htmlColor(stats[i].player);
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].ktotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].gotKilled;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].ratio;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].dtotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].tktotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].tkdtotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += stats[i].suicides;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#909090>";
					zeile += "<a href=\"";
					if (h>0)zeile += plainName(stats[i].player);
					else zeile += filename+"/"+plainName(stats[i].player);
					zeile += ".html\">info</a></td>";
					
					br.write(zeile,0,zeile.length());
					br.newLine();
					

				} else {
					zeile = "<td bgcolor=#707070>";
					zeile += htmlColor(stats[i].player);
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].ktotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].gotKilled;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].ratio;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].dtotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].tktotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].tkdtotal;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += stats[i].suicides;
					zeile += "</td>";
					br.write(zeile,0,zeile.length());
					br.newLine();
					zeile = "<td bgcolor=#707070>";
					zeile += "<a href=\"";
					if (h>0)zeile += plainName(stats[i].player);
					else zeile += filename+"/"+plainName(stats[i].player);
					zeile += ".html\">info</a></td>";
					
					br.write(zeile,0,zeile.length());
					br.newLine();
					
				}
				
				br.write("</tr>",0,"</tr>".length());
					br.newLine();
			}
			br.write("</table>",0,"</table>".length());
			br.newLine();
		  	
			zeile = "<table width=100% border=0 cellspacing=0 cellpadding=5><tr>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			
			
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Player total</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Kills total</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Deaths total</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>TKs total</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<th align=left bgcolor=#000000 text=#FFFFFF>Suicides total</th>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			
			br.write("<tr>",0,"<tr>".length());
			br.newLine();
			
			zeile = "<td bgcolor=#A0A0A0>";
			zeile += +rawStats.length;
			zeile += "</td>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<td bgcolor=#A0A0A0>";
			zeile += +rawStats.kills;
			zeile += "</td>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<td bgcolor=#A0A0A0>";
			zeile += +rawStats.deaths;
			zeile += "</td>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<td bgcolor=#A0A0A0>";
			zeile += +rawStats.tks;
			zeile += "</td>";
			br.write(zeile,0,zeile.length());
			br.newLine();
			zeile = "<td bgcolor=#A0A0A0>";
			zeile += +rawStats.suicides;
			zeile += "</td>";
			br.write(zeile,0,zeile.length());
			br.newLine();
				
				
			br.write("</tr>",0,"</tr>".length());
			br.newLine();

			
			br.write("</table>",0,"</table>".length());
					br.newLine();
		  	
			zeile = "<br><hr>HTML Page generated with Abraxas java Analyzer - <a href='http://www.wolfshorst.de'>http://www.wolfshorst.de</a></body></html>";
			br.write(zeile,0,zeile.length());
			br.newLine();
	
		  	br.close();
			System.out.println("\t done.");
		  	h++;
		  	if (h > 6) break;
		  	br=new BufferedWriter(new FileWriter(OUTDIR+filename+"/"+filename2+h+".html"));
		  	stats = currPlayers.getStats(h);
		}
		  new indexWriter(OUTDIR);
		  
		}catch(Exception e){
		    tf_oEinheit.setText("Die Datei konnte nicht erstellt werden.");
		     e.printStackTrace();
	    	System.out.println(e.getMessage());
		    return;
		}
    	}

	}
    //==================================================================================================//
    //==================================================================================================//
}

//======================================================================================================//
//---------------------------------------------EOF------------------------------------------------------//
//======================================================================================================//
