import java.util.Vector;
import PlayerStats;
import java.io.*;

public class RtCWPlayer	implements Serializable
{
	/**Methode aus dem Interface Serializable
	 */
	public void toStream(OutputStream fo)
	throws IOException
   	{
		ObjectOutputStream oo = new ObjectOutputStream(fo);
		oo.writeObject(this);
   	 }
        /**Methode aus dem Interface Serializable
	 */
        public  RtCWPlayer fromStream(InputStream fi)
	throws IOException,ClassNotFoundException
    	{
		ObjectInputStream oi = new ObjectInputStream(fi);
		RtCWPlayer player = (RtCWPlayer)oi.readObject();
		return player;
    	}
	
//=============================================================================//
//-----------------------------KONSTANTEN SYMBOLE------------------------------//
//=============================================================================//
	public static final int IKILLEDYOU	=	0;
	public static final int YOUKILLEDME	=	1;
	public static final int RATIO		=	2;
	public static final int ITKYOU		=	2;
	public static final int YOUTKME		=	3;
	public static final int SUICIDE		=	5;
	public static final int KILLED		=	6;
	public static final int TK		=	3;
	public static final int TKD		=	4;
	
	public static final int UNKNOWN		=	0;
	public static final int MP40 		=	1;
	public static final int THOMPSON	=	2;
	public static final int STEN		=	3;
	public static final int KNIFE		=	4;
	public static final int LUGER		=	5;
	public static final int COLT		=	6;
	public static final int GRENADE		=	7;
	public static final int AIRSTRIKE	=	8;
	public static final int VENOM		=	9;
	public static final int FLAMER		=	10;
	public static final int PANZER		= 	11;
	public static final int DYNAMITE	=	12;
	public static final int MG42		=	13;
	public static final int SNIPER		= 	14;
	public static final int FELL		=	0;//Unknow for now ---TO DO!!!!!!!
	public static final int SLASHKILL	=	0;//Unknow for now ---TO DO!!!!!!!
	public static final String[] WEAPONNAME = {"Unknown","MP40","Thompson","Sten","Knife","Luger",".45ACP",
				"Grenade","Airstrike","Venom","Flamer","Panzer","Dynamite","MG42","Sniper"};
//=============================================================================//
//----------------------------KLASSE KILLINGPARTNER----------------------------//
//=============================================================================//
 	private class killingPartner implements Serializable
	{
	    
		String name;
		int[] killWeapons;
		int[] deathWeapons;
		int[] kills;
	         //Zeiger auf das naechste Listenelement
		killingPartner next;
		
		/**Methode aus dem Interface Serializable
	 */
	public void toStream(OutputStream fo)
	throws IOException
   	{
		ObjectOutputStream oo = new ObjectOutputStream(fo);
		oo.writeObject(this);
   	 }
        /**Methode aus dem Interface Serializable
	 */
        public  killingPartner fromStream(InputStream fi)
	throws IOException,ClassNotFoundException
    	{
		ObjectInputStream oi = new ObjectInputStream(fi);
		killingPartner partner = (killingPartner)oi.readObject();
		return partner;
    	}
	
	    //----------------------------------------------------------------//
		killingPartner(String n, int kill, String weapon)
		{
			killWeapons = new int[15];
			deathWeapons = new int[15];
			kills = new int[4];
			for (int i=0;i<4;i++) kills[i] = 0;
			for (int i=0;i<15;i++)
			{
				killWeapons[i]     = 0;
				deathWeapons[i]    = 0;
				
			}
			name = n;
			next = null;
			youAgain(weapon,kill);
		}
	    //--------------------------------------------------------------//
		killingPartner(String n)
		{
			killWeapons = new int[15];
			deathWeapons = new int[15];
			kills = new int[4];
			for (int i=0;i<4;i++) kills[i] = 0;
			for (int i=0;i<15;i++)
			{
				killWeapons[i]     = 0;
				deathWeapons[i]    = 0;
			       
			}
			name = n;
			next = null;
		}
	    //--------------------------------------------------------------//
		void youAgain(String weapon, int kill)
		{
			kills[kill]++;
			if (weapon != null) 
			{
				if (kill == IKILLEDYOU) killWeapons[RtCWPlayer.weapon(weapon)]++;
				if (kill == YOUKILLEDME) deathWeapons[RtCWPlayer.weapon(weapon)]++;
			}
		}
		
	    //--------------------Wie heisst er?---------------------------//
		String getName()
		{
			return name;
		}
	    //--------------------Womit toetet er?------------------------//
		int[] getKillWeapons()
		{
			return killWeapons;
		}
	    //-------------------Womit wird er gettet?-------------------//
		int[] getDeathWeapons()
		{
			return deathWeapons;
		}
	    //----------------Wie oft ttet er?--------------------------//
		int getKills()
		{
			return kills[IKILLEDYOU];
		}
	    //----------------Wie oft wird er gekillt?------------------//
		int getKilledBy()
		{
			return kills[YOUKILLEDME];
		}
	    //----------------Wie oft TEAMKILLT er?-------------------//
		int getTKills()
		{
			return kills[ITKYOU];
		}
	    //--------------Wie oft wurde er geTEAMKILLT?--------------//
		int getTKillsBy()
		{
			return kills[YOUTKME];
		}
	}//*End Class killingPartner*//
  
//=============================================================================//
//----------------Class RTCWPLAYER---------------------------------------------//
//=============================================================================//
 	String name;
	killingPartner 	killedPlayers;
	int [] killWeapons;
	int [] deathWeapons;
	int [] suicideWeapons;
	int numberOfGames;
	int kills;
	int deaths,gotKilled;
	int teamKills,gotTeamKilled;
	int suicides;
	int friends;
	int currStreak=0,longestStreak=0;
    //------------------------------------------------------------------------//
	/**Konstruktor fr einen neuen RtCWPlayer. bekommt den namen des
	 * spielers uebergeben.
	 */
	public RtCWPlayer(String n)
	{
		name 			=  n;
		numberOfGames   	=  1;
		kills 	        	=  0;
		deaths	        	=  0;
		teamKills       	=  0;
		suicides        	=  0;
		friends			=  0;
		killedPlayers   	=  null;
		deathWeapons		=  new int[15];
		killWeapons		=  new int[15];
		suicideWeapons		=  new int[15];
	
		for (int i=0;i<15;i++)
		{
			killWeapons[i]  	= 0;
			deathWeapons[i] 	= 0;
			suicideWeapons[i] 	= 0;
		}
	}
    //--------------------------------------------------------------------//
	public static int weapon(String name)
	{
		if (name.compareTo("MP40")==0) 		return MP40;
		if (name.compareTo("Thompson")==0) 	return THOMPSON;
		if (name.compareTo("support")==0) 	return AIRSTRIKE;
		if (name.compareTo("support fire")==0) 	return AIRSTRIKE;
		if (name.compareTo("Sten")==0) 		return STEN;
		if (name.compareTo("sniper")==0) 	return SNIPER;
		if (name.compareTo("sniper rifle")==0) 	return SNIPER;
		if (name.compareTo("Mauser")==0) 	return SNIPER;
		if (name.compareTo("Luger")==0) 	return LUGER;
		if (name.compareTo("Luger 9mm")==0) 	return LUGER;
		if (name.compareTo("crew-served")==0) 	return MG42;
		if (name.compareTo("crew-served MG42")==0) 	return MG42;
		if (name.compareTo("'s .45ACP 1911")==0)return COLT;
		if (name.compareTo(".45ACP 1911")==0)	return COLT;
		if (name.compareTo("Colt")==0)	   	return COLT;
		if (name.compareTo("grenade")==0) 	return GRENADE;
		if (name.compareTo("grenade.")==0) 	return GRENADE;
		if (name.compareTo("Venom")==0) 	return VENOM;
		if (name.compareTo("flamethrower")==0)	return FLAMER;
		if (name.compareTo("Panzerfaust")==0) 	return PANZER;
		if (name.compareTo("dynamite")==0) 	return DYNAMITE;
		if (name.compareTo("knife")==0) 	return KNIFE;
		if (name.compareTo("fell")==0) 		return FELL;
		if (name.compareTo("himself.")==0) 	return SLASHKILL;
		//System.out.println(name);
		return UNKNOWN;
		
	}
    //------------------------------------------------------------------//
	
	private int add(killingPartner p)
	{
		killingPartner m = killedPlayers;
		friends++;
		if (m==null)
		{ 
			//es gibt noch keine liste, also muss ne neue her.
			killedPlayers = p;
			return 0;
		}
		
		//das Ende suchen.
		while (m.next != null) m = m.next;
		//den neuen anfuegen
		m.next = p;
		//sicher gehen
		p.next = null;
		return 0;
	}
    //------------------------------------------------------------------//
	private killingPartner find(String n)
	{
		killingPartner m;
		killingPartner p;

		p = killedPlayers; 
		if (p==null){ killedPlayers = new killingPartner(n);
		friends++;
						return killedPlayers;}
		
		
		while (p!=null && (p.getName().compareTo(n) != 0)) p = p.next;
		
		if (p == null) 
		{
			m = new killingPartner(n);
			add(m);
		} else m=p;

		return m;

	}
    //----------------------------------------------------------------------------//
	private boolean isIn(String n)
	{
		killingPartner m;
		killingPartner p;

		p = killedPlayers; 
		if (p==null)	return false;
		
		
		while (p!=null && (p.getName().compareTo(n) != 0)) p = p.next;
		
		if (p == null) 
			return false;
		return true;

	}
    //-----------------------------------------------------------------------------//
	public void killed(String victim, String weapon)
	{
		
		kills++;
		
		find(victim).youAgain(weapon,IKILLEDYOU);
				
		killWeapons[weapon(weapon)]++;
		
		currStreak++;
	}
    //-------------------------------------------------------------------------------//
	public void gotKilled(String killer, String weapon)
	{
		deaths++;
		gotKilled++;
		find(killer).youAgain(weapon,YOUKILLEDME);
		
		deathWeapons[weapon(weapon)]++;
		if (currStreak > longestStreak) longestStreak = currStreak;
		currStreak = 0;
	}
	
	public void killedHimSelf(String weapon)
	{
		deaths++;
		suicides++;
		if (weapon != null)
			suicideWeapons[weapon(weapon)]++;
		if (currStreak > longestStreak) longestStreak = currStreak;
		currStreak = 0;
	}
	
	public int compare(int f)
	{
		switch (f)
		{
			case IKILLEDYOU: 	return kills;
			case YOUKILLEDME: 	return deaths;
			case TK: 		return teamKills;
			case TKD: 		return gotTeamKilled;
			case SUICIDE: 		return suicides;
			case KILLED:		return gotKilled;
			default: 		return 0;
		}
			
	}
	
	public float rateCompare()
	{
		return getKillDeathRatio();
	}
	

	public void died()
	{
		deaths++;
		if (currStreak > longestStreak) longestStreak = currStreak;
		currStreak = 0;
	}
	
	public void teamKilled(String victim)
	{
		teamKills++;
				
		find(victim).youAgain(null,ITKYOU);
				
	}
	
	public void gotTeamKilled(String killer)
	{
		int i;
		gotTeamKilled++;
		deaths++;
       
		find(killer).youAgain(null,YOUTKME);
		if (currStreak > longestStreak) longestStreak = currStreak;
		currStreak = 0;
		
		
	}
	
	public int getStreak()
	{
		return longestStreak;
	}
	public String getName()
	{
		return name;
	}
	
	public void connect()
	{
		numberOfGames++;
	}
	
	public int getNumberOfGames()
	{
		return numberOfGames;
	}
	
	public float getAvgFragsPerGame()
	{
		return (float)kills/(float)numberOfGames;
	}
	public float getKillDeathRatio()
	{
	    if (gotKilled == 0) return (float)kills;
		return (float)kills/(float)gotKilled;
	}
	public int getKills()
	{
		return kills;
	}
	
	public int getTeamKills()
	{
		return teamKills;
	}
	
	public int getDeaths()
	{
		return deaths;
	}
	
	public int getKilled()
	{
		return gotKilled;
	}
	
	public int getSuicides()
	{
		return suicides;
	}
	
	public static void main(String [] args)
	{
		RtCWPlayer p=new RtCWPlayer("Abraxas");
		p.killed("a","MP40");
		System.out.println(p.getKills());
		p.killed("b","MP40");System.out.println(p.getKills());
		p.killed("c","MP40");System.out.println(p.getKills());
		p.killed("a","MP40");System.out.println(p.getKills());
		p.killed("d","MP40");System.out.println(p.getKills());
		p.killed("e","MP40");System.out.println(p.getKills());
		p.killed("b","MP40");System.out.println(p.getKills());
		p.killed("a","MP40");System.out.println(p.getKills());
		p.gotKilled("a","MP40");System.out.println(p.getDeaths());
		p.gotKilled("b","MP40");System.out.println(p.getDeaths());
		p.gotKilled("z","MP40");System.out.println(p.getDeaths());
		p.gotKilled("z","MP40");System.out.println(p.getDeaths());
		p.gotTeamKilled("a");
		p.gotTeamKilled("c");
		p.gotTeamKilled("a");
		p.gotTeamKilled("c");
		p.teamKilled("z");
		p.teamKilled("z");
		p.teamKilled("b");
		p.teamKilled("b");
		p.teamKilled("b");
		p.killedHimSelf(null);

		System.out.println(p.getKills());
		
		p.printPartners();
	}

	public PlayerStats getStats()
	{
		killingPartner p = killedPlayers;
		
		PlayerStats stats = new PlayerStats(friends,kills,gotKilled,deaths,teamKills,gotTeamKilled,
                                           suicides,name,getKillDeathRatio(),longestStreak);
		
		stats.specifyWeapons(killWeapons,deathWeapons,suicideWeapons);
		int i=0;
		while(p!=null)
		{
		     //System.out.println(p.getTKillsBy());
			stats.add(i,p.getName(),p.getKills(),p.getKilledBy(),p.getTKills(),p.getTKillsBy());
			
			p=p.next;
			i++;
		}
		return stats;
	}

	public void printPartners()
	{

		getStats().print();
		
	}
}
